# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['DnsNameserversArgs', 'DnsNameservers']

@pulumi.input_type
class DnsNameserversArgs:
    def __init__(__self__, *,
                 nameservers: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        The set of arguments for constructing a DnsNameservers resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        pulumi.set(__self__, "nameservers", nameservers)

    @property
    @pulumi.getter
    def nameservers(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

    @nameservers.setter
    def nameservers(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "nameservers", value)


@pulumi.input_type
class _DnsNameserversState:
    def __init__(__self__, *,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering DnsNameservers resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        if nameservers is not None:
            pulumi.set(__self__, "nameservers", nameservers)

    @property
    @pulumi.getter
    def nameservers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

    @nameservers.setter
    def nameservers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "nameservers", value)


class DnsNameservers(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        The dns_nameservers resource allows you to configure DNS nameservers for your Tailscale network. See https://tailscale.com/kb/1054/dns for more information.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tailscale as tailscale

        sample_nameservers = tailscale.DnsNameservers("sample_nameservers", nameservers=[
            "8.8.8.8",
            "8.8.4.4",
        ])
        ```

        ## Import

        ID doesn't matter.

        ```sh
        $ pulumi import tailscale:index/dnsNameservers:DnsNameservers sample dns_nameservers
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DnsNameserversArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The dns_nameservers resource allows you to configure DNS nameservers for your Tailscale network. See https://tailscale.com/kb/1054/dns for more information.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tailscale as tailscale

        sample_nameservers = tailscale.DnsNameservers("sample_nameservers", nameservers=[
            "8.8.8.8",
            "8.8.4.4",
        ])
        ```

        ## Import

        ID doesn't matter.

        ```sh
        $ pulumi import tailscale:index/dnsNameservers:DnsNameservers sample dns_nameservers
        ```

        :param str resource_name: The name of the resource.
        :param DnsNameserversArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DnsNameserversArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DnsNameserversArgs.__new__(DnsNameserversArgs)

            if nameservers is None and not opts.urn:
                raise TypeError("Missing required property 'nameservers'")
            __props__.__dict__["nameservers"] = nameservers
        super(DnsNameservers, __self__).__init__(
            'tailscale:index/dnsNameservers:DnsNameservers',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'DnsNameservers':
        """
        Get an existing DnsNameservers resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DnsNameserversState.__new__(_DnsNameserversState)

        __props__.__dict__["nameservers"] = nameservers
        return DnsNameservers(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def nameservers(self) -> pulumi.Output[Sequence[str]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

